// αチャンネルで切り抜いて保存する
function batchCropImage()
{
	motoFile = File.openDialog("αチャンネル画像ファイルを指定してください");	// 切り抜くαがある画像ファイルのパス
	if (!motoFile) return;
	imageFolder = Folder.selectDialog("切り抜かれる画像があるフォルダを選択してください");	// 切り抜かれる画像があるフォルダ
	if (!imageFolder) return;
	saveFolder = Folder.selectDialog("保存するフォルダを選択してください");	// 切り抜かれた画像の保存先フォルダ
	if (!saveFolder) return;
	fileList = imageFolder.getFiles("*.jpg");	// PSDの場合はpsdにする
	for(i=0; i<fileList.length; i++)
	{
		fileObj = new File(fileList[i]);
		if (fileObj.open("r") == true)
		{
			// 画像の配置
			open(fileObj);
			activeDocument.selection.selectAll();	// 全てを選択
			activeDocument.activeLayer.copy();	// コピー
			activeDocument.close(SaveOptions.DONOTSAVECHANGES);
			open(motoFile);
			chObj = activeDocument.channels[3];	// アルファチャンネル1を読み込み
			activeDocument.selection.load(chObj);	// アルファチャンネルを選択
			activeDocument.paste(true);	// 選択範囲内にペースト
			savePSD(saveFolder+"/"+fileList[i].name+".psd");	// ファイル保存
			activeDocument.close(SaveOptions.DONOTSAVECHANGES);
		}
	}
}
// PSD形式で保存
function savePSD(psdFileObj)
{
	var saveFileObj = new File(psdFileObj);
	var psdOpt = new PhotoshopSaveOptions();
	psdOpt.alphaChannels = true;	// チャンネルを保存する
	psdOpt.annotations = true;	
	psdOpt.embedColorProfile = false;	// カラープロファイルは埋め込まない
	psdOpt.layers = true;	// レイヤー情報は保存する
	psdOpt.spotColors = false;
	activeDocument.saveAs(saveFileObj, psdOpt, true, Extension.LOWERCASE);
}
batchCropImage();

